SystemOrganization addCategory: #'OB-TraitsIntegration'!

OBCmdClassTemplate subclass: #OBCmdNewTraitTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdNewTraitTemplate methodsFor: 'accessing' stamp: 'dc 4/23/2007 15:03'!
label
	^ 'new trait template'! !

!OBCmdNewTraitTemplate methodsFor: 'private' stamp: 'dc 7/22/2007 21:04'!
templateDefinition
	^ OBClassDefinition 
			environment: self currentEnvironment
			template: (Trait newTemplateIn: self currentCategory)! !

!OBCmdFindClass class methodsFor: '*ob-traitsIntegration' stamp: 'dc 5/17/2007 12:57'!
on: target for: requestor
	^ OBCmdFindClassOrTrait new setTarget: target requestor: requestor! !

OBCmdFindClass subclass: #OBCmdFindClassOrTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdFindClassOrTrait methodsFor: 'private' stamp: 'dc 5/17/2007 12:54'!
allBehaviorsIn: anEnvironment
	^ Array streamContents: [:stream|
		
		stream
			nextPutAll: anEnvironment classNames;
			nextPutAll: anEnvironment traitNames 
		
		]! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'jk 6/20/2007 17:23'!
cmdBrowseMethodImplementor
	^ OBCmdBrowseMethodImplementor! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'ab 6/5/2007 23:50'!
cmdBrowseTraitUser
	^OBCmdBrowseTraitUsers! !

!OBCodeBrowser methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/23/2007 15:04'!
cmdNewTraitTemplate
	^ OBCmdNewTraitTemplate ! !

!TCommentDescription methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:34'!
asCommentNode
	^ OBClassCommentNode on: self theNonMetaClass 
! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:34'!
asClassSideNode
	^ OBMetaclassNode on: self
! !

!Trait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:35'!
asNode
	^ OBClassNode on: self
! !

!OBAnnotationRequest methodsFor: '*ob-traitsIntegration' stamp: 'jk 6/20/2007 14:03'!
messageComesFrom
	class isNil ifTrue: [^ String new].
	selector isNil ifTrue: [^ class printString ].
	^ (class traitOrClassOfSelector: selector) printString! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:33'!
asClassSideNode
	^ OBMetaclassNode on: self baseTrait
! !

!ClassTrait methodsFor: '*ob-traitsIntegration' stamp: 'dc 4/21/2007 15:33'!
asNode
	^ OBMetaclassNode on: self
! !

!OBMethodDefinition methodsFor: '*ob-traitsintegration-confirming' stamp: 'jk 8/22/2007 19:44'!
confirmCompileLocalyOrInUsedTrait: aTrait 
	| result prompt m1 m2 m3 r1 r3 |
	prompt := 'You are compiling a method that already exists in a
used trait. What do you want to do:' translated.
	r1 := self compileClass.
	r3 := nil.
	m1 := 'Compile the method in the class ' translated , r1 asString.
	m2 := 'Compile the method in the trait ' translated , aTrait asString.
	m3 := 'Cancel' translated.
	result := OBChoiceRequest
				prompt: prompt
				labels: (Array with: m1 with: m2 with: m3)
				values: (Array with: r1 with: aTrait with: r3 ).
	result = aTrait
		ifTrue: [self compileClass: aTrait].
	result isNil
		ifTrue: [^ false].
	^ true! !

!OBMethodDefinition methodsFor: '*ob-traitsintegration-validation' stamp: 'jk 8/22/2007 19:48'!
validateMethodOfUsedTrait
	| messageLocation |
	
	messageLocation := self compileClass traitOrClassOfSelector: self compileSelector.
	self compileClass = messageLocation ifTrue: [^ true]. "it is local message"
	messageLocation isTrait ifTrue: 
		[^ self confirmCompileLocalyOrInUsedTrait: messageLocation ].
	^ true! !

OBCommand subclass: #OBCmdBrowseMethodImplementor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdBrowseMethodImplementor methodsFor: 'execution' stamp: 'jk 6/20/2007 16:33'!
execute
	| class |
	class := target theClass traitOrClassOfSelector: target selector.
	(OBMethodNode on: target selector inClass: class) browse! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:34'!
group
	^ #navigation! !

!OBCmdBrowseMethodImplementor methodsFor: 'testing' stamp: 'jk 6/20/2007 16:28'!
isActive
	^ (target isKindOf: OBMethodNode)
		and: [requestor isSelected: target]! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:38'!
keystroke
	^ $M! !

!OBCmdBrowseMethodImplementor methodsFor: 'accessing' stamp: 'jk 6/20/2007 16:27'!
label
	^ 'browse method implementor'! !

OBCommand subclass: #OBCmdBrowseTraitUsers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OB-TraitsIntegration'!

!OBCmdBrowseTraitUsers methodsFor: 'execution' stamp: 'ab 6/6/2007 00:00'!
execute
	| users usersNames selection |
	"ugly hack to get rid of double..."
	users := target theClass users asOrderedCollection asSet asOrderedCollection.
	(users size = 0)
		ifTrue: [Beeper beep. ^ self].
	(users size = 1)
		ifTrue: [users first browse. ^ self].
		
	usersNames := users asOrderedCollection collect: [:clsOrTrait| clsOrTrait name].
	selection := OBChoiceRequest prompt: nil labels: usersNames values: users.
	selection ifNotNil: [selection browse].! !

!OBCmdBrowseTraitUsers methodsFor: 'testing' stamp: 'ab 6/5/2007 23:52'!
isActive

	^ ((target isKindOf: OBClassNode) and: 
		[target theClass isTrait]) and:
			[requestor isSelected: target]! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
keystroke
	^ $u! !

!OBCmdBrowseTraitUsers methodsFor: 'accessing' stamp: 'ab 6/5/2007 23:48'!
label
	^ 'browse trait users...'! !
